/*
** FILE NAME:   Correl.c
**
** PROJECT ID:  
**
**
** AUTHOR:      D. Maidment
**
** DESCRIPTION: This file generates white noise, then takes the 
**              autocorrelation to determine the 'randomness' of the signal
**
** MODIFICATION HISTORY:
**
**              1.00    15-NOV-95
**
*/
#include <stdio.h>
#include <math.h>
#include <ensigdsp.h>
#include "testhead.h"
#include "dave.txt"

#define NSAMP     32              /* number of samples */
#define NSAMPL    64
#define NOCORR    400
#define TWOPI     6.283185307

/***************** Exercise To Autocorrelate White Noise *******************/


void 
main()
{

        short   signal[NSAMPL], noise[NSAMPL], noise_a[NSAMP], output[NOCORR], sine[NSAMP];
        long    no_samples, no_samp, no_corr;
        float   varience;
        int     res_shift, n, k, len;


        no_samples = NSAMPL;
        no_samp    = NSAMP;
        varience   = 100;
        res_shift  = 0;
        no_corr    = NOCORR;
        len        = NSAMP;

/***        for( n = 0; n < 101; n ++) **/
/***        {                           **/
/***        noise_a[n] = noise[n];      **/
/***        }                           **/

        

/*** Generate Noise ***/


        printf("Generating Noise ....... ");                     
        if(GenGWnoise( noise, no_samples, varience) != EDSP_OK) 
        printf("Bad Argument In GenGWnoise");                   



/*** Generate Sine Wave ***/

        printf("Generating Sine Wave");
        k = len / 20;
        for(n = 0; n <= NSAMP; n++)
        {
        sine[n] = (10 * cos(TWOPI * k * n / len));
        }
        printf("Done");

/*** Generate Noisy Signal ***/

        for(n = 0; n<= NSAMPL; n++)
        {
        signal[n] = (noise[n] + receive[n]);
        }

/******************************/
        
/*** Autocorrelation ***/

        printf("Finding Autocorrelation..... ");
        if(Correlate( output, transmit, signal, no_samp, no_samples, no_corr, res_shift) != EDSP_OK)
        printf("Bad Argument In Correlate");
    

        printf("Autocorrelation done");
        printf("Solution in Output");

}

