/*

** FILE NAME:	demoio.c

**

** PROJECT ID:	94-0040

**

** TITLE:	File providing a basic data i/o interface for demo.c

**

** AUTHOR:	Ensigma Ltd.

**

** DESCRIPTION:	This file provides a basic i/o interface for demo.c

**		It is intended for use with a simulator that can handle

**		printf()'s.

**

** MODIFICATION HISTORY:

**

**              1.00    15-Sep-95       Initial Revision

**

*/

#include <stdio.h>

#include <math.h>

#include "demoio.h"



#define 	TWOPI 	6.28318530717959



/*

** FUNCTION:    Error

**

** DESCRIPTION: Error handler

**

*/

void 

Error(char *err)

{

    printf("%s", err);

}



/*

** FUNCTION:    GetData

**

** DESCRIPTION:	Generate a signal consisting of the sum of two sinusoids

**		one at 1/8 sampling rate the other at 3/8 sampling rate.

**

*/

void 

GetData(short *input, int len)

{

    int k, i;



    k = len / 8;

    for (i = 0; i < len; i++)

	input[i] = floor(16383 * cos(TWOPI * k * i / len) + 0.5);



    k = len * 3 / 8;

    for (i = 0; i < len; i++)

	input[i] += floor(16383 * cos(TWOPI * k * i / len) + 0.5);

}



/*

** FUNCTION:    OutRes

**

** DESCRIPTION: Echo results

**

*/

void 

OutRes(char *mess)

{

    printf("%s", mess);

}



/*

** FUNCTION:    OutSpect

**

** DESCRIPTION: Output complex-valued spectrum

**

*/

void 

OutSpect(short *dat, int len)

{

    int i;



    for (i = 0; i < len; i += 2)

	printf("\nfr[%d]=%d, fi[%d]=%d", i, dat[i], i, dat[i + 1]);

}

