;
; FILE NAME:    mean.asm
;
; PROJECT ID:   94-0040
;
; TITLE:        Mean
;
; AUTHOR:       Ensigma Ltd.
;
; DESCRIPTION:  This file contains the mean function.
;

	.EXPORT	_Mean

;REGISTER USAGE
;
;R4 -> OUTPUT
;R5 -> INPUT
;R6 -> NO

	.SECTION	P,CODE,ALIGN=4

; Preserve registers on stack
_Mean:	MOV.L	R14,@-R15	;PUSH REGISTERS ON STACK
	MOV.L	R13,@-R15
	MOV.L	R12,@-R15
	MOV.L	R11,@-R15
	MOV.L	R10,@-R15
	MOV.L	R9,@-R15
	MOV.L	R8,@-R15
	STS.L	MACH,@-R15
	STS.L	MACL,@-R15
	STS.L	PR,@-R15

; Error checking
	CMP/PL	R6		;NO >0 ?
	BT	argOK

	BRA	RTN
	MOV	#1,R0		;R0= RETURN CODE

	.ALIGN	4
argOK:	MOV	R6,R7
	SHLL	R7
	MOV	UPMASK,R11	;MASK AWAY UPPER 30 BITS
	ADD	R5,R7		;R7=LAST DATA ADDRESS + 2
	AND	R6,R11		;R11=LOWER 2 BITS

	SHLL2	R11		;R11*4
	MOVA	NX,R0
	SUB	R11,R0		;R0=ADDRESS OF LB - R11*2
	JMP	@R0		;R0=JUMP ADDRESS
	MOV	#0,R1

	.ALIGN	4
loop:	MOV.W	@R5+,R2
	ADD	R2,R1
	MOV.W	@R5+,R2
	ADD	R2,R1
	MOV.W	@R5+,R2
	ADD	R2,R1
	MOV.W	@R5+,R2
	ADD	R2,R1
NX:	CMP/EQ	R5,R7
	BF	loop

	MOV	R6,R7
	SHLR	R7

	MOV	R1,R13		;SAVE SIGN
	CMP/PZ	R1
	BT	DIVI1
	SUB	R7,R1		;ADD ROUNDING FOR -VE NO
	BRA	DIVI2
	NEG	R1,R1		;NEGATE -VE NO

DIVI1:	ADD	R7,R1		;ADD ROUNDING FOR +VE NO
DIVI2:	SHLL16	R6		;UPPER 16 BITS=DIVISOR
	DIV0U			;FLAG INITIALISATION
	.arepeat	16
	DIV1	R6,R1		;REPEAT 16 TIMES
	.aendr
	ROTCL	R1
	EXTU.W	R1,R2		;R2=QUOTIENT

	CMP/PZ	R13
	BT	OUTPUT
	NEG	R2,R2
OUTPUT:	MOV.W	R2,@R4		;OUTPUT RESULT

	MOV	#0,R0		;RETURN CODE
RTN:	LDS.L	@R15+,PR
	LDS.L	@R15+,MACL
	LDS.L	@R15+,MACH
	MOV	@R15+,R8
	MOV	@R15+,R9
	MOV	@R15+,R10
	MOV	@R15+,R11
	MOV	@R15+,R12
	MOV	@R15+,R13
	RTS
	MOV	@R15+,R14

	.ALIGN	4
UPMASK	.data.l	H'00000003

	.END
