/*
** FILE NAME:	min.c
**
** PROJECT ID:	94-0040
**
** TITLE:	MinI
**
** AUTHOR:	Ensigma Ltd.
**
** DESCRIPTION:	This routine searches input to find the first element with
**		the minimum value, and returns its address in min_ptr.
**
**		int MinI(min_ptr, input, no_elements)
**
** PARAMETERS:
**              short **min_ptr     : address of pointer to minimum element
**              short input []      : array of input data
**              long no_elements    : size of the input buffer
**
** RETURNS:     EDSP_OK             : success
**              EDSP_BAD_ARG        : no_elements < 1
**
** MODIFICATION HISTORY:
**              1.0  15-9-95    Initial revision
*/

#include <math.h>
#include <ensigdsp.h>

int 
MinI(short **min_ptr, short input[], long no_elements)
{
    /* Variable Declaration */
    int i, location = 0;
    short temp;

    /* Input argument error checking */
    if (no_elements < 1)
	return EDSP_BAD_ARG;

    temp = input[0];		/* Variable initialisation */

    for (i = 1; i < no_elements; i++)	/* Main Loop */
    {
	if (temp > input[i])	/* Test for Minimum */
	{
	    temp = input[i];	/* Store the minimum value */
	    location = i;	/* Store the index */
	}
    }

    *min_ptr = &input[location];/* Store the location */

    return EDSP_OK;
}
