;
; FILE NAME:    mspower.asm
;
; PROJECT ID:   94-0040
;
; TITLE:        MsPower
;
; AUTHOR:       Ensigma Ltd.
;
; DESCRIPTION:  This file contains the power function.
;

	.EXPORT	_MsPower

;REGISTER USAGE
;
;R4 -> OUTPUT
;R5 -> INPUT
;R6 -> NO

	.SECTION	P,CODE,ALIGN=4

; Preserve registers on stack
_MsPower:	MOV.L	R14,@-R15	;PUSH REGISTERS ON STACK
	MOV.L	R13,@-R15
	MOV.L	R12,@-R15
	MOV.L	R11,@-R15
	MOV.L	R10,@-R15
	MOV.L	R9,@-R15
	MOV.L	R8,@-R15
	STS.L	MACH,@-R15
	STS.L	MACL,@-R15
	STS.L	PR,@-R15

; Error checking
	CMP/PL	R6		;NO >0 ?
	BT	argOK

ERR:	BRA	RTN
	MOV	#1,R0		;R0= RETURN CODE

	.ALIGN	4
argOK:	MOV	R6,R8
	SHLL	R8
	ADD	R5,R8		;R8=LAST DATA ADDRESS + 2

	MOV	#0,R13		;R12:R13=SUM=0
	MOV	#0,R12
	MOV	#0,R3
	CLRT

loop:	MOV.W	@R5+,R1		;READ X(I)
	MULS	R1,R1		;SQUARE IT
	STS	MACL,R1
	ADDC	R1,R13		;SUM IT
	ADDC	R3,R12		;ADD CARRY
	CMP/EQ	R5,R8
	BF	loop

	MOV	R6,R9
	SHLR	R9
	CLRT
	ADDC	R9,R13		;ADD ROUNDING
	ADDC	R3,R12

	DIV0U			;FLAG INITIALISATION
	.arepeat	32
	ROTCL	R13		;REPEAT 32 TIMES
	DIV1	R6,R12
	.aendr
	ROTCL	R13		;R13=QUOTIENT

	MOV.L	R13,@R4		;OUTPUT VARIANCE

	MOV	#0,R0		;RETURN CODE
RTN:	LDS.L	@R15+,PR
	LDS.L	@R15+,MACL
	LDS.L	@R15+,MACH
	MOV	@R15+,R8
	MOV	@R15+,R9
	MOV	@R15+,R10
	MOV	@R15+,R11
	MOV	@R15+,R12
	MOV	@R15+,R13
	RTS
	MOV	@R15+,R14

	.END
