/*
** FILE NAME:	mspower.c
**
** PROJECT ID:	94-0040
**
** TITLE:	MsPower
**
** AUTHOR:	Ensigma Ltd.
**
** DESCRIPTION:	This routine calculates the Mean Square Power of the input.
**
**		int MsPower(output, input, no_elements)
**
** PARAMETERS:
**              long output[]       : output
**              short input[]       : input
**              long no_elements    : number of elements to evaluate
**
** RETURNS:     EDSP_OK             : success
**              EDSP_BAD_ARG        : no_elements < 1
**
** MODIFICATION HISTORY:
**              1.0  15-9-95    Initial revision
*/

#include <math.h>
#include <ensigdsp.h>

int 
MsPower(long *output, const short input[], long no_elements)
{
    /* Variable Declaration */
    int i;
    double temp;

    /* Input Argument Error checking */
    if (no_elements < 1)
	return EDSP_BAD_ARG;

    temp = 0;			/* variable initialisation */

    for (i = 0; i < no_elements; i++)	/* Main Loop */
	temp += (double)input[i] * input[i];

    /* Rounding */
    *output = floor(temp / no_elements + 0.5);

    return EDSP_OK;		/* Return success */

}
