/****************************************************************************
*
*	Contains the low level routine used by malloc() etc. to obtain more
*	memory from the heap. The maximum available heap is defined by the
*	symbol HEAPSIZE.
*
*****************************************************************************/

/* Size of area managed by sbrk. */
#define HEAPSIZE 200000

union {
        long dummy;
        char heap[HEAPSIZE];
}heap_area;

extern char *brk_pointer;

/**************************************************************************
*
* sbrk()
*
* Return value: Start address of assigned area on success, -1 on failure
*
****************************************************************************/

char *sbrk(unsigned long size)
{
        char *p;

        if (brk_pointer+size>heap_area.heap+HEAPSIZE)
                return (char *)-1;

        p=brk_pointer;
        brk_pointer += size;

        return p;

}
