/*
** FILE NAME:   testconv.c
**
** PROJECT ID:  94-0040
**
** TITLE:       File that tests all the DSPLIB Convolution/Correlation
**              functions
**
** AUTHOR:      Ensigma Ltd.
**
** DESCRIPTION: The file allocates a character array and calls each
**              test function in turn which writes into this array.
**
** MODIFICATION HISTORY:
**
**              1.00    15-Sep-95       Initial Revision
**
*/
#include <stdio.h>
#include <ensigdsp.h>
#include "testhead.h"

#define NFN     20              /* number of functions */
/*#define NOPRINTF*/

#ifdef NOPRINTF
int 
printf(const char *rcode,...)
{

}
#endif

char rcode[NFN][100];

void 
main()
{
    int find;

    for (find = 0; find < NFN; find++)
	rcode[find][0] = '\0';

    find = 0;
    printf("Testing Convolution/Correlation routines\n");
    printf("Testing ConvComplete\n");
    Tconvcmp(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing ConvPartial\n");
    Tconvpar(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing ConvCyclic\n");
    Tconvcyc(rcode[find]);
    printf("%s", rcode[find++]);
}
