/*
** FILE NAME:   testfilt.c
**
** PROJECT ID:  94-0040
**
** TITLE:       File that tests all the DSPLIB filter functions
**
** AUTHOR:      Ensigma Ltd.
**
** DESCRIPTION: The file allocates a character array and calls each
**              test function in turn which writes into this array.
**
** MODIFICATION HISTORY:
**
**              1.00    15-Sep-95       Initial Revision
**
*/
#include <stdio.h>
#include <ensigdsp.h>
#include "testhead.h"

#define NFN     20              /* number of functions */
/*#define NOPRINTF*/

#ifdef NOPRINTF
int 
printf(const char *rcode,...)
{
}
#endif

char rcode[NFN][100];

void 
main()
{
    int find;

    for (find = 0; find < NFN; find++)
	rcode[find][0] = '\0';

    find = 0;
    printf("Testing Filter routines\n");
    printf("Testing Fir\n");
    Tstfir(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing Fir1\n");
    Tstfir1(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing Iir\n");
    Tstiir(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing Iir1\n");
    Tstiir1(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing DIir\n");
    Tstdiir(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing DIir1\n");
    Tstdiir1(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing Lms\n");
    Tstlms(rcode[find]);
    printf("%s", rcode[find++]);
    printf("Testing Lms1\n");
    Tstlms1(rcode[find]);
    printf("%s", rcode[find++]);
}
