/*
** FILE NAME:	triangle.c
**
** PROJECT ID:	94-0040
**
** TITLE:	GenTriangle
**
** AUTHOR:	Ensigma Ltd.
**
** DESCRIPTION:	This file contains the routines used to generate the Triangle
**              window.
**
**		int GenTriangle(output, win_size)
**
** PARAMETERS:
**              short output[]       : array to contain window
**              long win_size        : size of window
**
** RETURNS:     EDSP_OK              : success
**              EDSP_BAD_ARG         : win_size < 2
**
** MODIFICATION HISTORY:
**              1.0  15-9-95    Initial revision
*/
#include <math.h>
#include <ensigdsp.h>

int
GenTriangle(short output[], long win_size)
{
    /* Variable Declaration */
    int i;
    double j;

    if (win_size <= 1)		/* Input Argument error checking */
	return EDSP_BAD_ARG;

    for (i = 0; i < win_size; i++)
    {
	j = (2.0 * i - win_size + 1) / (win_size + 1.0);

	output[i] = floor((32767 * (1.0 - fabs(j))) + 0.5);
    }

    return EDSP_OK;

}
