/*
**      File Name:      Window.c
**      
**      Author:         D. Maidment
**
**      Date            23/10/95
**
**      Description:    This file is a testbed for the four window
**                      functions offered by the DSP library.
**                      Library functions used:
**                          GenHamming()
**                          GenBlackman()
**                          GenHanning()
**                          GenTriangle()
*/
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <float.h>
#include <ensigdsp.h>
#include "tstwin.txt"

#define         VLEN    32 /* Window Length */
#define         SC      32767
#define         TWOPI   6.283185307179


        short    LEN;
        short    EHamming[VLEN];
        double   DHamming[VLEN];
        short    EBlackman[VLEN];
        double   DBlackman[VLEN];
        short    EHanning[VLEN];
        double   DHanning[VLEN];
        short    ETriangle[VLEN];
        double   DTriangle[VLEN];
        double   ErrorBlack;
        double   ErrorHamm;
        double   ErrorHann;
        double   ErrorTrian;

main()
{
/* Generate Windows Using Ensigma Libraries */

        GenHamming(EHamming, VLEN);
        GenBlackman(EBlackman, VLEN);
        GenHanning(EHanning, VLEN);
        GenTriangle(ETriangle, VLEN);
        
/* Calculate Window Functions*/

/* Blackman Window */
        printf(" Calculating Windows ...... ");
        Genwin();
        printf(" Done ");


        printf(" Calculating Errors ........ ");
        Generror();
        printf(" Done ");


        printf("Task Complete");
}
/***************************************************************************/
double
Genwin()
{

        for ( LEN = 0; LEN < VLEN; LEN ++)
        {
                DBlackman[LEN] = (SC * ((0.42 - 0.5 * (cos((TWOPI * LEN / VLEN)))) + 0.08 * (cos((2 * TWOPI * LEN) / VLEN ))));
        }

/* Hamming Window */

        for ( LEN = 0; LEN < VLEN; LEN ++)
        {
                DHamming[LEN] = (SC * (0.54 - 0.46 * cos(TWOPI * LEN / VLEN)));

        }
/* Hanning Window */

        for ( LEN = 0; LEN < VLEN; LEN ++)
        {
                DHanning[LEN] = (SC * 0.5 * (1.0 - cos(TWOPI * LEN / VLEN)));

        }

/* Triangle Window */


        for ( LEN = 0; LEN < VLEN; LEN ++)
        {
                DTriangle[LEN] = (SC * (1.0 - fabs((2.0 * LEN - VLEN + 1.0) / (VLEN + 1.0))));
        }

}
/****************************************************************************/



/**********************************************************************/
double
Generror()
{
/* Calculate Difference */

        for ( LEN = 0; LEN < VLEN; LEN ++)
        {
                ErrorBlack += (wbla[LEN] - DBlackman[LEN]) * (wbla[LEN] - DBlackman[LEN]);
                ErrorHamm  += (wham[LEN] - DHamming[LEN]) * (wham[LEN] - DHamming[LEN]);
                ErrorHann  += (whan[LEN] - DHanning[LEN]) * (whan[LEN] - DHanning[LEN]);
                ErrorTrian += (wtri[LEN] - DTriangle[LEN]) * (wtri[LEN] - DTriangle[LEN]);
        }


/**********************************************************************/
} 
